'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactFrameComponent = require('react-frame-component');

var _reactFrameComponent2 = _interopRequireDefault(_reactFrameComponent);

var _iconFullScreen = require('./icon-full-screen');

var _iconFullScreen2 = _interopRequireDefault(_iconFullScreen);

var shouldObserveHead = process.env.NODE_ENV === 'development' && typeof MutationObserver !== 'undefined';

var devices = [{ name: 'iPhone 4', value: '320x480' }, { name: 'iPhone 5', value: '320x568' }, { name: 'iPhone 6', value: '375x627' }, { name: 'iPhone 6 Plus', value: '414x736' }, { name: 'iPad', value: '768x1024' }, { name: 'Nexus 4', value: '384x567' }, { name: 'Nexus 5', value: '360x567' }, { name: 'Nexus 6', value: '412x659' }, { name: 'Nexus 7', value: '600x960' }, { name: 'Nexus 10', value: '800x1280' }];

var styles = {
  container: {
    fullScreen: {
      position: 'fixed',
      top: 0,
      left: 0,
      bottom: 0,
      right: 0,
      background: '#eee',
      overflow: 'auto',
      padding: '1em',
      zIndex: 999
    },
    'default': {
      position: 'relative',
      background: '#eee',
      overflow: 'auto',
      padding: '1em'
    }
  },
  form: {
    absolute: {
      position: 'absolute',
      top: 0,
      right: 0,
      background: '#f0f0f0',
      border: '1px solid #ccc',
      borderTopColor: '#ddd',
      borderBottomWidth: '2px',
      padding: '0.5em'
    },
    top: {
      background: '#303030',
      borderBottom: '2px solid #000',
      margin: '-1em -1em 1em -1em',
      padding: '1em',
      color: '#eee'
    }
  },
  inputs: {
    display: 'inline-block',
    marginLeft: '1em'
  },
  input: {
    width: '5em',
    background: 'transparent',
    border: '0',
    borderBottom: '1px solid #ccc',
    padding: '0.1em 0.5em',
    color: 'inherit'
  },
  x: {
    fontFace: 'sans-serif',
    fontSize: '0.6666em',
    display: 'inline-block',
    margin: '0 0.333em'
  },
  button: {
    fontSize: '0.666em',
    height: '1.1666rem',
    float: 'right'
  }
};

// grab all of the document style and link tags and to inject into our iFrame
// component
var documentHead = function documentHead() {
  return typeof document !== 'undefined' && _react2['default'].createElement(
    'head',
    null,
    Array.prototype.slice.call(document.head.children, 0).map(function (child, index) {
      return child.tagName === 'STYLE' && child.type === 'text/css' ? _react2['default'].createElement(
        'style',
        { key: index, type: 'text/css' },
        child.textContent
      ) : child.tagName === 'LINK' && child.rel === 'stylesheet' ? _react2['default'].createElement('link', { key: index, rel: 'stylesheet', href: child.href }) : null;
    })
  );
};

var ResponsiveIframe = (function (_Component) {
  _inherits(ResponsiveIframe, _Component);

  function ResponsiveIframe(props, context) {
    var _this = this;

    _classCallCheck(this, ResponsiveIframe);

    _get(Object.getPrototypeOf(ResponsiveIframe.prototype), 'constructor', this).call(this, props, context);

    this.state = {
      width: 0,
      height: 0,
      formPosition: 'top',
      isFullScreen: false
    };
    this.onChange = function (event) {
      var _event$target = event.target;
      var name = _event$target.name;
      var value = _event$target.value;

      _this.setState(_defineProperty({}, name, value));
    };
    this.handleChangeSelect = function (event) {
      var _event$target$value$split$map = event.target.value.split('x').map(function (n) {
        return +n;
      });

      var _event$target$value$split$map2 = _slicedToArray(_event$target$value$split$map, 2);

      var width = _event$target$value$split$map2[0];
      var height = _event$target$value$split$map2[1];

      if (width === 'Custom') return;
      _this.setState({ width: width, height: height });
    };

    this.onSubmit = function (event) {
      return event.preventDefault();
    };

    this.toggleFormPosition = function (event) {
      _this.setState({
        formPosition: _this.state.formPosition === 'top' ? 'absolute' : 'top'
      });
    };

    this.toggleFixed = function (event) {
      _this.setState({ isFullScreen: !_this.state.isFullScreen });
    };

    if (shouldObserveHead) {
      this.observer = true;
    }
  }

  _createClass(ResponsiveIframe, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      if (typeof document === 'undefined') return;

      if (shouldObserveHead) {
        var target = document.head;
        // this is a bit of hack to keep the iframe synced with local dev
        // stylesheets
        this.observer = new MutationObserver(function (mutations) {
          _this2.forceUpdate();
        });

        var config = { childList: true, characterData: true };
        this.observer.observe(target, config);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (shouldObserveHead) {
        this.observer.disconnect();
        this.observer = null;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state;
      var width = _state.width;
      var height = _state.height;

      var frameStyle = {
        background: '#fff',
        border: '1px solid #e0e0e0',
        width: width || '100%',
        height: height || null,
        display: 'block',
        margin: '0 auto'
      };

      var containerStyles = styles.container[this.state.isFullScreen ? 'fullScreen' : 'default'];
      return _react2['default'].createElement(
        'div',
        { style: containerStyles },
        _react2['default'].createElement(
          'form',
          {
            onSubmit: this.onSubmit,
            style: styles.form[this.state.formPosition]
          },
          _react2['default'].createElement(
            'select',
            { onChange: this.handleChangeSelect, value: width + 'x' + height },
            _react2['default'].createElement(
              'option',
              null,
              'Custom'
            ),
            devices.map(function (d) {
              return _react2['default'].createElement(
                'option',
                { key: d.name, value: d.value },
                d.name
              );
            })
          ),
          _react2['default'].createElement(
            'div',
            { style: styles.inputs },
            _react2['default'].createElement('input', {
              style: styles.input,
              placeholder: 'width',
              name: 'width',
              onChange: this.onChange,
              value: this.state.width || null }),
            _react2['default'].createElement(
              'span',
              { style: styles.x },
              '×'
            ),
            _react2['default'].createElement('input', {
              style: styles.input,
              placeholder: 'height',
              name: 'height',
              onChange: this.onChange,
              value: this.state.height || null })
          ),
          _react2['default'].createElement(
            'button',
            { onClick: this.toggleFixed, style: styles.button },
            _react2['default'].createElement(_iconFullScreen2['default'], null)
          ),
          _react2['default'].createElement(
            'button',
            { onClick: this.toggleFormPosition, style: styles.button },
            'Toggle'
          )
        ),
        _react2['default'].createElement(
          _reactFrameComponent2['default'],
          { style: frameStyle, head: documentHead() },
          this.props.children
        )
      );
    }
  }]);

  return ResponsiveIframe;
})(_react.Component);

exports['default'] = ResponsiveIframe;
module.exports = exports['default'];
